/* 変数の型のデータサイズ，データ範囲を表示 */
#include <stdio.h>
#include <float.h>   /* float，doubleに関するマクロを利用 */
#include <limits.h>  /* char, int, short, longなどに関するマクロを利用 */

int main(void)
{
  puts("***** char型の情報 *****");
  printf("サイズ:%d  範囲：%d 〜 %d\n", sizeof(char), CHAR_MIN, CHAR_MAX);

  puts("***** int型の情報 *****");
  printf("サイズ:%d  範囲：%d 〜 %d\n", sizeof(int), INT_MIN, INT_MAX);

  puts("***** short型の情報 *****");
  printf("サイズ:%d  範囲：%d 〜 %d\n", sizeof(short), SHRT_MIN, SHRT_MAX);

  puts("***** long型の情報 *****");
  printf("サイズ:%d  範囲：%ld 〜 %ld\n", sizeof(long), LONG_MIN, LONG_MAX);

  puts("***** unsinged char型の情報 *****");
  printf("サイズ:%d  範囲：0 〜 %u\n", sizeof(unsigned char), UCHAR_MAX);

  puts("***** unsinged int型の情報 *****");
  printf("サイズ:%d  範囲：0 〜 %u\n", sizeof(unsigned int), UINT_MAX);

  puts("***** unsinged short型の情報 *****");
  printf("サイズ:%d  範囲：0 〜 %u\n", sizeof(unsigned short), USHRT_MAX);

  puts("***** unsinged long型の情報 *****");
  printf("サイズ:%d  範囲：0 〜 %lu\n", sizeof(unsigned long), ULONG_MAX);

  puts("***** float型の情報 *****");
  printf("サイズ:%d  範囲：%g 〜 %g\n", sizeof(float), FLT_MIN, FLT_MAX);

  puts("***** double型の情報 *****");
  printf("サイズ:%d  範囲：%g 〜 %g\n", sizeof(double), DBL_MIN, DBL_MAX);

  puts("***** long double型の情報 *****");
  printf("サイズ:%d  範囲：%Lg 〜 %Lg\n", sizeof(long double), LDBL_MIN, LDBL_MAX);

  return 0;
}
