/* 構造体へのポインタ例．矢印演算子の利用 */
#include <stdio.h>
#include <string.h>

/* 構造体の定義 */
typedef struct seiseki{
  int num;           /* 学籍番号 */
  char name[20];     /* 氏名  */
  char sub[20];      /* 科目名 */
  int score;         /* 点数  */
} seiseki_t;

int main(void)
{                /* 構造体の変数の初期化 */
  seiseki_t a = { 3710, "Minamoto", "Math", 50}; 
  seiseki_t *p; /* 構造体へのポインタを宣言 */

  p = &a;   /* 構造体aの先頭アドレスをpに代入 */

  /* pが指す値を間接演算子で参照　*/
  printf("%d  %-20.20s %s \t %d\n", (*p).num, (*p).name, (*p).sub, (*p).score);

  /* 矢印演算子を使って，pが指す構造体のメンバへ値を代入 */
  p -> num = 1000;               /* (*p).num = 1000と同じ */ 
  strcpy( p -> name, "Saga" );   /* strcpy((*p).name, "Saga")と同じ */
  strcpy( p -> sub, "English");  /* strcpy((*p).sub,"English")と同じ */
  p -> score = 80;               /* (*p).score = 80 と同じ */

  /* pが指す値を矢印演算子を使って参照　*/
  printf("%d  %-20.20s %s \t %d\n", p->num, p->name, p->sub, p->score);

  return 0;
}
