/* 構造体の配列と関数の利用例 */
#include <stdio.h>
#include <string.h>

/* 構造体の定義 */
typedef struct seiseki{
  int num;           /* 学籍番号 */
  char name[20];     /* 氏名  */
  char sub[20];      /* 科目名 */
  int score;         /* 点数  */
} seiseki_t;


/* 構造体変数の入れ替え */
void swap_seiseki(seiseki_t *x, seiseki_t *y)
{
  seiseki_t tmp = *x;
  *x = *y ;
  *y = tmp ;
}

/* バブルソート(大きい順) */
void sort_by_score(seiseki_t a[], int n)
{
  int i, flag, tmp;
  do
  {
    flag = 0; /* 値の交換はないものとする */
    for( i = 0; i < n-1 ; i++ )
    {
      if( a[i].score < a[i+1].score )
      {
        swap_seiseki( &a[i], &a[i+1] ); 
        flag = 1 ;       /* 値の交換があればフラグを立てる */
      }
    }
  } while( flag == 1 );  /* 2つの数の交換がある間は続ける */ 
}

int main(void)
{                /* 構造体の配列の初期化 */
  seiseki_t a[] = { {1, "Abe", "Math", 72}, {2, "Beppu", "Jpn", 90},
                    {3, "Doi", "Eng", 85}, {4, "Egawa", "Art", 60} };
  int i, n;        /* カウンタ, 配列の要素数 */

  n = sizeof(a)/sizeof(a[0]); /* 配列の要素数を求める */

  sort_by_score(a, n); /* 得点の高い順に並べかえ */
  
  /* pが指す値を矢印演算子を使って参照　*/
  for ( i = 0; i < n ; i++ )
    printf("%d  %-20.20s %s \t %d\n", a[i].num, a[i].name, a[i].sub, a[i].score);

  return 0;
}
