/* テキストファイルとバイナリファイルへの出力 */
#include <stdio.h>
#include <stdlib.h> /* exit, srand, rand関数を使うのに必要 */
#include <time.h>   /* time関数を使うのに必要 */

int main(void)
{
  int i; 
  int a[100]; 
  FILE *fp; 

  if( (fp = fopen( "text.dat", "w" )) == NULL )
  {
    fprintf( stderr, "ファイルtext.datを作成できません\n");
    exit(1);
  }

  srand((unsigned)time(NULL)); /* time関数を使って乱数を初期化 */  
  for( i = 0 ; i < 100 ; i++)
  {
    a[i] = rand();   /* 乱数の発生 */
    fprintf( fp, "%d\n", a[i]); /* text.datに乱数を出力 */
  }

  fclose(fp); /* text.dat を閉じる */

  /* バイナリファイルの作成 */
  if( (fp = fopen( "binary.dat", "wb" )) == NULL )
  {
    fprintf( stderr, "ファイルbinary.datを作成できません\n");
    exit(1);
  }

  fwrite( a, sizeof(int), 100, fp); /* binary.datに乱数を出力 */

  fclose(fp); /* binary.dat を閉じる */

  return 0; 
}
